--IF RUNNING THIS SCRIPT IN SQL MGMT STUDIO
--1. FROM QUERY MENU, SELECT SQLCMD Mode
--2. UNCOMMENT LINE BELOW AND REPLACE "EN" WITH APPROPRIATE LANGUAGE CODE 
--:setvar languagecode "EN"

declare 
  @v_grid_name VARCHAR(6),
  @v_grid_id NUMERIC(14, 0),
  @v_field_id NUMERIC(14, 0),
  @v_field_id_list VARCHAR(1000),
  @v_grid_key_fields VARCHAR(200),
  @v_dataspy_id NUMERIC(14, 0),
  @sChk nvarchar(1);

-------------------------------------------------------------------------------
-- Set custom grid name
-------------------------------------------------------------------------------

set @v_grid_name = 'WUBOOK'; 

-------------------------------------------------------------------------------
-- Cleanup existing grid
-------------------------------------------------------------------------------
IF EXISTS (SELECT BOT_FUNCTION FROM r5boilertexts WHERE BOT_FUNCTION = @v_grid_name)
BEGIN
      DELETE FROM r5boilertexts where BOT_FUNCTION = @v_grid_name
END

IF EXISTS (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
BEGIN
	DELETE FROM r5queryfield where DQF_DDSPYID in (select DDS_DDSPYID from R5dddataspy where DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name))
	DELETE FROM R5USEGRIDSYSDEFAULT WHERE USD_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM R5dddataspy WHERE DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM r5gridfield where GFD_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM r5gridparam where gdp_gridid in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)	
	DELETE FROM r5grid WHERE GRD_GRIDNAME = @v_grid_name
END

IF EXISTS (SELECT FUN_CODE FROM r5functions WHERE FUN_CODE = @v_grid_name)
BEGIN
	DELETE FROM R5EXTMENULANG WHERE EML_EXTMENU IN (SELECT EMN_CODE FROM R5EXTMENUS WHERE EMN_FUNCTION = @v_grid_name);
	DELETE FROM R5EXTMENUS WHERE EMN_FUNCTION = @v_grid_name;
	DELETE FROM r5functions where FUN_CODE = @v_grid_name;
END

-------------------------------------------------------------------------------
--Insert r5functions
-------------------------------------------------------------------------------
INSERT INTO R5FUNCTIONS (FUN_CODE,FUN_DESC,FUN_CLASS,FUN_SUBTYPE,FUN_FILE,FUN_PUBLIC,FUN_SELECT,FUN_BACKGROUND,FUN_DIRSEL,FUN_SYSTEM,FUN_DISPLAYAP,FUN_DISPLAYFT,FUN_POPUPAP,FUN_POPUPFT,FUN_DESCCHANGED,FUN_CLASS_ORG,FUN_LST,FUN_RS,FUN_HDR,FUN_EWSREPORT,FUN_PRDDATASRC,FUN_EWSURLNEW,FUN_REPDISABLED,FUN_ADVREPT,FUN_MEKEY,FUN_EWSBTN)
 VALUES (@v_grid_name,'Work Order Labor (AM)','WEBD','M','R5MENU','-','?','-','-','+','-','+','-','-','-','*','+','-','-','-','-','-','-','-','YN','-');

-------------------------------------------------------------------------------
-- Insert r5grid
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_grid_id OUTPUT, 'GRD', '1', @sChk OUTPUT
INSERT INTO R5GRID (GRD_DESC,GRD_GRIDID,GRD_BASEQUERY,GRD_GRIDNAME,GRD_BOTFUNCTION,GRD_PORTLETFLAG,GRD_TAB,GRD_GRIDTYPE,GRD_OPTIMIZERON,GRD_DISTINCT,GRD_COMPLEX,GRD_ACTIVE,GRD_NOSCREENDESIGNER)
 VALUES ('Work Order Labor (AM)',@v_grid_id,'FROM ( 
    SELECT BOO_ACD, ''999999999'' AS BOO_EVENT, BOO_ACT, BOO_OCTYPE, BOO_DATE, BOO_PERSON, BOO_HOURS,
    BOO_TRADE, BOO_CODE, BOO_MRC, BOO_UPDATECOUNT, BOO_CORRECTION, BOO_ENTERED,
    BOO_ON, BOO_OFF, BOO_OCRTYPE, BOO_DESC, '''' AS EVT_ORG, '''' AS EVT_OBJECT,
    '''' AS EVT_OBJECT_ORG, '''' AS EVT_RSTATUS, '''' AS OBJ_PARENT
    FROM R5BOOKEDHOURS 
		WHERE BOO_OCRTYPE = ''X''    
    UNION      
	 SELECT BOO_ACD, BOO_EVENT, BOO_ACT, BOO_OCTYPE, BOO_DATE, BOO_PERSON, BOO_HOURS,
	 BOO_TRADE, BOO_CODE, BOO_MRC, BOO_UPDATECOUNT, BOO_CORRECTION, BOO_ENTERED,
	 BOO_ON, BOO_OFF, BOO_OCRTYPE, BOO_DESC, e.EVT_ORG as EVT_ORG, e.EVT_OBJECT as EVT_OBJECT,
	 e.EVT_OBJECT_ORG as EVT_OBJECT_ORG, e.EVT_RSTATUS AS EVT_RSTATUS, o.OBJ_PARENT as OBJ_PARENT 
	 FROM r5bookedhours,r5events e,r5ucodes u,r5activities a,r5objects o
		WHERE BOO_EVENT = e.evt_code
		AND boo_act = a.act_act
		AND e.evt_code = a.act_event		
		AND e.evt_rtype IN (''JOB'', ''PPM'')
		AND u.uco_rentity = ''JBTP''  
		and u.uco_code=e.evt_jobtype 
		AND u.uco_rcode IN ( ''*'', ''BR'', ''ST'', ''PM'', ''CAL'' ,''RP'', ''MEC'')
		AND e.evt_rstatus = ''R''
		AND e.evt_object = o.obj_code AND e.evt_object_org = o.obj_org
    ) x WHERE 1=1',@v_grid_name,@v_grid_name,'-','+',2,'-','-','+','+','-');

-------------------------------------------------------------------------------
-- Insert r5dddataspy
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_dataspy_id OUTPUT, 'DDS', '1', @sChk OUTPUT
INSERT INTO R5DDDATASPY (DDS_DDSPYNAME,DDS_DDSPYID,DDS_SCOPE,DDS_ORGANIZATION,DDS_CREATEDSTAMP,DDS_FILTERSTRXML,DDS_SORTSTRXML,DDS_OWNER,DDS_GRIDID,DDS_TYPE,DDS_DEFAULTFLAG,DDS_CLIENTROWS,DDS_BOTNAME,DDS_SECURITYDATASPY,DDS_MEKEY)
 VALUES ('All Records',@v_dataspy_id,'-','*',getdate(),'<FILTERABLE />','<SORTABLE><SORT_ELEMENT ALIAS_NAME="boo_entered" SEQNUM="1" TYPE="ASC"/><SORT_ELEMENT ALIAS_NAME="boo_acd" SEQNUM="2" TYPE="ASC"/></SORTABLE>','R5',@v_grid_id,'SD','+',30,'DSNAME','-','YY');

-------------------------------------------------------------------------------
-- Insert the three base r5boilertexts
-- Note: You must also insert a r5boilertext record for each "grid field" (see below)
-------------------------------------------------------------------------------

INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,1,100,0,0,'$(languagecode)','List View','TB','1','LST','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,2,100,0,0,'$(languagecode)','Work Order Labor (AM)','F','1','UDG_HDRLABEL','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,3,100,0,0,'$(languagecode)','All Records','F','1','DSNAME','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,4,100,0,0,'$(languagecode)','boo_acd','F','1','boo_acd','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,5,100,0,0,'$(languagecode)','boo_event','F','1','boo_event','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,6,100,0,0,'$(languagecode)','boo_act','F','1','boo_act','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,7,100,0,0,'$(languagecode)','boo_octype','F','1','boo_octype','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,8,100,0,0,'$(languagecode)','boo_date','F','1','boo_date','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,9,100,0,0,'$(languagecode)','boo_person','F','1','boo_person','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,10,100,0,0,'$(languagecode)','boo_hours','F','1','boo_hours','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,11,100,0,0,'$(languagecode)','boo_trade','F','1','boo_trade','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,12,100,0,0,'$(languagecode)','boo_code','F','1','boo_code','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,13,100,0,0,'$(languagecode)','boo_mrc','F','1','boo_mrc','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,14,100,0,0,'$(languagecode)','boo_updatecount','F','1','boo_updatecount','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,15,100,0,0,'$(languagecode)','boo_correction','F','1','boo_correction','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,16,100,0,0,'$(languagecode)','boo_entered','F','1','boo_entered','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,17,100,0,0,'$(languagecode)','evt_rstatus','F','1','evt_rstatus','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,18,100,0,0,'$(languagecode)','evt_org','F','1','evt_org','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,19,100,0,0,'$(languagecode)','boo_on','F','1','boo_on','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,20,100,0,0,'$(languagecode)','boo_off','F','1','boo_off','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,21,100,0,0,'$(languagecode)','boo_ocrtype','F','1','boo_ocrtype','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,22,100,0,0,'$(languagecode)','boo_desc','F','1','boo_desc','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,23,100,0,0,'$(languagecode)','evt_object','F','1','evt_object','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,24,100,0,0,'$(languagecode)','evt_object_org','F','1','evt_object_org','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,25,100,0,0,'$(languagecode)','evt_parent','F','1','evt_parent','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,26,100,0,0,'$(languagecode)','equipdesc','F','1','equipdesc','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,27,100,0,0,'$(languagecode)','parentequipdesc','F','1','parentequipdesc','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,28,100,0,0,'$(languagecode)','occtypedesc','F','1','occtypedesc','10000',getdate(),'-');

-------------------------------------------------------------------------------
-- Copy the R5BOILERTEXTS for each of the languages in the R5LANGINST
-------------------------------------------------------------------------------

INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED)
SELECT BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,LIN_CODE,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED
FROM R5BOILERTEXTS, R5LANGINST
WHERE
BOT_LANG = '$(languagecode)' AND BOT_FUNCTION = @v_grid_name AND lin_code <> '$(languagecode)'

-------------------------------------------------------------------------------
-- Insert r5ddfield, r5gridfield, r5queryfield for each grid field
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_acd','NUMBER','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,4,'TEXT','boo_acd','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',1,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_event','VARCHAR','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,5,'TEXT','boo_event','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',2,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_act','NUMBER','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,6,'TEXT','boo_act','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',3,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_octype','VARCHAR','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,7,'TEXT','boo_octype','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',4,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_date','DATETIME','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,8,'TEXT','boo_date','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',5,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_person','VARCHAR','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,9,'TEXT','boo_person','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',6,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'case when (-0.0001 < boo_hours AND boo_hours < 0.0001) then 0 else boo_hours end','DECIMAL','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,10,'TEXT','boo_hours','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',7,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_trade','VARCHAR','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,11,'TEXT','boo_trade','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',8,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
set @v_grid_key_fields =  LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_code','NUMBER','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,12,'TEXT','boo_code','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',9,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_mrc','VARCHAR','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,13,'TEXT','boo_mrc','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',10,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_updatecount','NUMBER','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,14,'TEXT','boo_updatecount','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',11,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_correction','VARCHAR','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,15,'TEXT','boo_correction','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',12,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_entered','DATETIME','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,16,'TEXT','boo_entered','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',13,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'evt_rstatus','VARCHAR','R5EVENTS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,17,'TEXT','evt_rstatus','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',14,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'evt_org','VARCHAR','R5EVENTS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,18,'TEXT','evt_org','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',15,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_on','NUMBER','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,19,'TEXT','boo_on','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',16,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_off','NUMBER','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,20,'TEXT','boo_off','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',17,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_ocrtype','VARCHAR','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,21,'TEXT','boo_ocrtype','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',18,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'boo_desc','VARCHAR','R5BOOKEDHOURS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,22,'TEXT','boo_desc','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',19,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'evt_object','VARCHAR','R5EVENTS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,23,'TEXT','evt_object','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',20,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'evt_object_org','VARCHAR','R5EVENTS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,24,'TEXT','evt_object_org','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',21,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'OBJ_PARENT','VARCHAR','R5OBJECTS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,25,'TEXT','obj_parent','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',22,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'case when (evt_object = '''' or evt_object is null) then evt_object else dbo.R5O7_O7GET_DESC(:parameter.language,''OBJ'', evt_object + ''#'' + evt_object_org,'''', '''') end','MIXVARCHAR','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,26,'TEXT','equipdesc','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',23,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'case when (OBJ_PARENT = '''' or OBJ_PARENT is null) then OBJ_PARENT else dbo.R5O7_O7GET_DESC(:parameter.language,''OBJ'', OBJ_PARENT + ''#'' + evt_object_org,'''', '''') end','MIXVARCHAR','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,27,'TEXT','parentequipdesc','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',24,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'dbo.R5O7_O7GET_DESC(:parameter.language,''UCOD'', BOO_OCTYPE, ''OCTP'', '''')','MIXVARCHAR','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,28,'TEXT','occtypedesc','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',25,'LIST');


-------------------------------------------------------------------------------
-- Insert r5gridparam
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
-- Setup field keys on r5grid
-------------------------------------------------------------------------------

update r5grid set 
grd_keyfields = @v_grid_key_fields, 
grd_filterablelist = @v_field_id_list,
grd_sortablelist = @v_field_id_list,
grd_displayablelist = @v_field_id_list
where grd_gridid = @v_grid_id;
