--IF RUNNING THIS SCRIPT IN SQL MGMT STUDIO
--1. FROM QUERY MENU, SELECT SQLCMD Mode
--2. UNCOMMENT LINE BELOW AND REPLACE "EN" WITH APPROPRIATE LANGUAGE CODE 
--:setvar languagecode "EN"

declare 
  @v_grid_name VARCHAR(6),
  @v_grid_id NUMERIC(14, 0),
  @v_field_id NUMERIC(14, 0),
  @v_field_id_list VARCHAR(1000),
  @v_grid_key_fields VARCHAR(200),
  @v_dataspy_id NUMERIC(14, 0),
  @sChk nvarchar(1);

-------------------------------------------------------------------------------
-- Set custom grid name
-------------------------------------------------------------------------------

set @v_grid_name = 'WUSTWO'; 

-------------------------------------------------------------------------------
-- Cleanup existing grid
-------------------------------------------------------------------------------
IF EXISTS (SELECT BOT_FUNCTION FROM r5boilertexts WHERE BOT_FUNCTION = @v_grid_name)
BEGIN
      DELETE FROM r5boilertexts where BOT_FUNCTION = @v_grid_name
END

IF EXISTS (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
BEGIN
	DELETE FROM r5queryfield where DQF_DDSPYID in (select DDS_DDSPYID from R5dddataspy where DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name))
	DELETE FROM R5USEGRIDSYSDEFAULT WHERE USD_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM R5dddataspy WHERE DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM r5gridfield where GFD_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM r5gridparam where gdp_gridid in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)	
	DELETE FROM r5grid WHERE GRD_GRIDNAME = @v_grid_name
END

IF EXISTS (SELECT FUN_CODE FROM r5functions WHERE FUN_CODE = @v_grid_name)
BEGIN
	DELETE FROM R5EXTMENULANG WHERE EML_EXTMENU IN (SELECT EMN_CODE FROM R5EXTMENUS WHERE EMN_FUNCTION = @v_grid_name);
	DELETE FROM R5EXTMENUS WHERE EMN_FUNCTION = @v_grid_name;
	DELETE FROM r5functions where FUN_CODE = @v_grid_name;
END

-------------------------------------------------------------------------------
--Insert r5functions
-------------------------------------------------------------------------------
INSERT INTO R5FUNCTIONS (FUN_CODE,FUN_DESC,FUN_CLASS,FUN_SUBTYPE,FUN_FILE,FUN_PUBLIC,FUN_SELECT,FUN_BACKGROUND,FUN_DIRSEL,FUN_SYSTEM,FUN_DISPLAYAP,FUN_DISPLAYFT,FUN_POPUPAP,FUN_POPUPFT,FUN_DESCCHANGED,FUN_CLASS_ORG,FUN_LST,FUN_RS,FUN_HDR,FUN_EWSREPORT,FUN_PRDDATASRC,FUN_EWSURLNEW,FUN_REPDISABLED,FUN_ADVREPT,FUN_MEKEY,FUN_EWSBTN)
 VALUES (@v_grid_name,'Standard Work Orders (AM)','WEBD','M','R5MENU','-','?','-','-','+','-','+','-','-','-','*','+','-','-','-','-','-','-','-','YN','-');

-------------------------------------------------------------------------------
-- Insert r5grid
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_grid_id OUTPUT, 'GRD', '1', @sChk OUTPUT
INSERT INTO R5GRID (GRD_DESC,GRD_GRIDID,GRD_BASEQUERY,GRD_GRIDNAME,GRD_BOTFUNCTION,GRD_PORTLETFLAG,GRD_TAB,GRD_GRIDTYPE,GRD_OPTIMIZERON,GRD_DISTINCT,GRD_CUSTOMFIELDCODE,GRD_COMPLEX,GRD_ACTIVE,GRD_NOSCREENDESIGNER)
 VALUES ('Standard Work Orders (AM)',@v_grid_id,'FROM r5standworks
    WHERE stw_jobtype IN
    (
        SELECT u.uco_code
        FROM r5ucodes u
        WHERE u.uco_rcode IN (''*'',''BR'',''PM'',''ST'', ''CAL'',''RP'')
        AND u.uco_rentity = ''JBTP''
    )',@v_grid_name,@v_grid_name,'-','+',2,'+','-','STWO=STW_CODE','-','+','-');

-------------------------------------------------------------------------------
-- Insert r5dddataspy
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_dataspy_id OUTPUT, 'DDS', '1', @sChk OUTPUT
INSERT INTO R5DDDATASPY (DDS_DDSPYNAME,DDS_DDSPYID,DDS_SCOPE,DDS_ORGANIZATION,DDS_CREATEDSTAMP,DDS_FILTERSTRXML,DDS_SORTSTRXML,DDS_OWNER,DDS_GRIDID,DDS_TYPE,DDS_DEFAULTFLAG,DDS_CLIENTROWS,DDS_BOTNAME,DDS_SECURITYDATASPY,DDS_MEKEY)
 VALUES ('All Records',@v_dataspy_id,'-','*',getdate(),'<FILTERABLE />','<SORTABLE />','R5',@v_grid_id,'SD','+',30,'DSNAME','-','YY');

-------------------------------------------------------------------------------
-- Insert the three base r5boilertexts
-- Note: You must also insert a r5boilertext record for each "grid field" (see below)
-------------------------------------------------------------------------------

INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,1,100,0,0,'$(languagecode)','List View','TB','1','LST','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,2,100,0,0,'$(languagecode)','Standard Work Orders (AM)','F','1','UDG_HDRLABEL','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,3,100,0,0,'$(languagecode)','All Records','F','1','DSNAME','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,4,100,0,0,'$(languagecode)','stw_code','F','1','stw_code','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,5,100,0,0,'$(languagecode)','stw_desc','F','1','stw_desc','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,6,100,0,0,'$(languagecode)','stw_org','F','1','stw_org','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,7,100,0,0,'$(languagecode)','stw_reqm','F','1','stw_reqm','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,10,100,0,0,'$(languagecode)','stw_object','F','1','stw_object','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,11,100,0,0,'$(languagecode)','stw_class','F','1','stw_class','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,12,100,0,0,'$(languagecode)','stw_class_org','F','1','stw_class_org','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,13,100,0,0,'$(languagecode)','stw_template','F','1','stw_template','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,14,100,0,0,'$(languagecode)','stw_jobtype','F','1','stw_jobtype','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,15,100,0,0,'$(languagecode)','o7get_desc','F','1','o7get_desc','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,16,100,0,0,'$(languagecode)','stw_duration','F','1','stw_duration','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,17,100,0,0,'$(languagecode)','stw_woclass','F','1','stw_woclass','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,18,100,0,0,'$(languagecode)','stw_woclass_org','F','1','stw_woclass_org','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,20,100,0,0,'$(languagecode)','stw_priority','F','1','stw_priority','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,22,100,0,0,'$(languagecode)','stw_object_org','F','1','stw_object_org','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,23,100,0,0,'$(languagecode)','stw_objclass','F','1','stw_objclass','10000',getdate(),'-');

-------------------------------------------------------------------------------
-- Copy the R5BOILERTEXTS for each of the languages in the R5LANGINST
-------------------------------------------------------------------------------

INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED)
SELECT BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,LIN_CODE,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED
FROM R5BOILERTEXTS, R5LANGINST
WHERE
BOT_LANG = '$(languagecode)' AND BOT_FUNCTION = @v_grid_name AND lin_code <> '$(languagecode)'

-------------------------------------------------------------------------------
-- Insert r5ddfield, r5gridfield, r5queryfield for each grid field
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = LTRIM(RTRIM(str(@v_field_id)));
set @v_grid_key_fields =  LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_code','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,4,'TEXT','stw_code','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',1,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'dbo.R5O7_O7GET_DESC(:parameter.language, ''STWO'', STW_CODE, '''', '''')','MIXVARCHAR','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,5,'TEXT','stw_desc','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',2,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_org','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,6,'TEXT','stw_org','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',3,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_reqm','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,7,'TEXT','stw_reqm','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',4,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_object','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,10,'TEXT','stw_object','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',5,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_class','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,11,'TEXT','stw_class','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',6,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_class_org','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,12,'TEXT','stw_class_org','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',7,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_template','CHKBOOLEAN','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,13,'CHECKBOX','stw_template','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',8,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_jobtype','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,14,'TEXT','stw_jobtype','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',9,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'dbo.R5O7_O7GET_DESC(:parameter.language,''UCOD'', stw_jobtype,''JBTP'', '''')','MIXVARCHAR','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,15,'TEXT','o7get_desc','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',10,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_duration','NUMBER','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,16,'TEXT','stw_duration','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',11,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_woclass','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,17,'TEXT','stw_woclass','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',12,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_woclass_org','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,18,'TEXT','stw_woclass_org','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',13,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'stw_priority','VARCHAR','R5STANDWORKS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,20,'TEXT','stw_priority','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',14,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'COALESCE(stw_object_org, ''*'')','VARCHAR','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,22,'TEXT','stw_object_org','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',15,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'COALESCE(STW_OBCLASS, ''*'')','VARCHAR','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,23,'TEXT','stw_objclass','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',16,'LIST');


-------------------------------------------------------------------------------
-- Insert r5gridparam
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
-- Setup field keys on r5grid
-------------------------------------------------------------------------------

update r5grid set 
grd_keyfields = @v_grid_key_fields, 
grd_filterablelist = @v_field_id_list,
grd_sortablelist = @v_field_id_list,
grd_displayablelist = @v_field_id_list
where grd_gridid = @v_grid_id;
